﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using RobotCtrl;

namespace RobotView
{
    public partial class LampView : UserControl
    {
        private bool state;
        public bool State
        {
            get
            {
                return this.state;
            }
            set
            {
                setValue(value);
            }
        }

        private LampView()
        {
            InitializeComponent();
            this.Width = Resource1.LAMP_OFF.Width;
            this.Height = Resource1.LAMP_OFF.Height;
            this.State = false;
        }

        private DigitalOut digitalOut;
        private int bitIndex;
        public LampView(DigitalOut digitalOut, int bitIndex)
            : this()
        {
            this.digitalOut = digitalOut;
            this.bitIndex = bitIndex;
        }

        private void setValue(bool state)
        {
            if (this.InvokeRequired)
            {
                //VARIANTE 1:
                this.Invoke(new Action<bool>(setValue), state);
                return;
                
                /*//VARIANTE 2:
                BeginInvoke(new Action(() =>
                {
                    pictureBox.Image = (state) ? Resource1.LAMP_ON : Resource1.LAMP_OFF;
                    this.state = state;
                }));*/
            }

            //VARIANTE 1:
            pictureBox.Image = (state) ? Resource1.LAMP_ON : Resource1.LAMP_OFF;
            this.state = state;

        }
    }
}
