﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using RobotCtrl;

namespace RobotView
{
    public partial class SwitchView : UserControl
    {
        public event EventHandler<EventArgs> Switched;

        private bool swtch;

        public bool Switch
        {
            get { return swtch; }
            set { SwitchValue(value); }
        }

        private SwitchView()
        {
            InitializeComponent();

            this.Width = Resource1.SWITCH_OFF.Width;
            this.Height = Resource1.SWITCH_OFF.Height;

            this.pictureBox.Image = Resource1.SWITCH_OFF;
        }

        private DigitalIn digitalIn;
        private int bitIndex;
        public int BitIndex
        {
            get { return bitIndex; }
        }
        public SwitchView(DigitalIn digitalIn, int bitIndex): this()
        {
            this.digitalIn = digitalIn;
            this.bitIndex = bitIndex;
        }

        public bool SwitchValue(bool switchValue)
        {
            if (this.InvokeRequired)
            {
                //Use Func<> instead of Action<> if return value is required
                return (bool)this.Invoke(new Func<bool, bool>(SwitchValue), switchValue);
            }

            this.swtch = switchValue;
            pictureBox.Image = (swtch) ? Resource1.SWITCH_ON : Resource1.SWITCH_OFF;

            if (digitalIn != null)
            {
                digitalIn[bitIndex] = swtch;
            }
            return swtch;
            
        }

        private void pictureBox_Click(object sender, EventArgs e)
        {
            SwitchValue(!swtch);
            if (Switched != null)
            {
                Switched(this, EventArgs.Empty);
            }
        }
    }
}
